#! /usr/bin/env mpscript 
 
""":"
exec python $0 ${1+"$@"}
"""
#

import Tkinter 
import Pmw
import fpformat
import string
 
class MpVariableView(Pmw.MegaWidget):
    def __init__(self, parent = None, **kw):
        # Define the megawidget options.
        optiondefs = (
	    ('variable',       None,            Pmw.INITOPT),
	    ('recordlist',  None,            Pmw.INITOPT),
	    ('orient',      'horizontal',    Pmw.INITOPT),
	    ('label',        None,            None),
	    ('title',       None,            None),
	    ('value',       0,               None),
            ('format',      8,               None),
            ('fg',          'blue',          None),
        )
        self.defineoptions(kw, optiondefs)
 
        # Initialise base class (after defining options).
        Pmw.MegaWidget.__init__(self, parent)
 
        # Create the components.
        interior = self.interior()
        
        # get the MX related stuff
        reclist = self['recordlist']
        self.variable = reclist.get_record(self['variable'])
        self.master = parent
        self.format = self['format']
        label = self['label']
        if len(string.strip(label)) == 0:
             label = self['motor']
        # Create the motorname component.
        self.label = self.createcomponent('label',
                (), None,
                Tkinter.Label, interior, width = (len(label)+2),text = label)
 
        # Create the valueview component.
        self.lwt = 0.000
        self.view = self.createcomponent('view',
                (), None,
                Tkinter.Label, interior, width = 8,text = self.lwt, fg= self['fg'])
 
	# Use grid to position all components
	if self['orient'] == 'vertical':
	    self.label.grid(row = 1, column = 1)
	    self.view.grid(row = 2, column = 1)
	else:
	    self.label.grid(row = 1, column = 1)
	    self.view.grid(row = 1, column = 2)
        # Check keywords and initialise options.
        self.initialiseoptions(MpVariableView)

        self.update_label()
 
    def update_label(self):
        position = self.variable.read()
        self.lwt = fpformat.fix(position[0],self.format)
        self.view.configure(text=self.lwt)
        self.master.update_idletasks()
        self.master.after(100,self.update_label)

Pmw.forwardmethods(MpVariableView, Tkinter.Label, 'view')
 
# Initialise Tkinter and Pmw.
def main(record_list, argv):
    root = Pmw.initialise()
    root.title('Pmw MpVariableView demonstration')

    # Create and pack two ThresholdScale megawidgets.
    mega3 = MpVariableView(root,orient='vertical', recordlist = record_list, variable = 'id_ev_harmonic', label = 'Undulator Harmonic',format = 3)
    mega3.pack(side = 'top', padx = 10, pady = 10)
    # Let's go.
    root.mainloop()
